"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadPolygonShape = exports.loadTriangleShape = exports.loadGenericPolygonShape = void 0;
const PolygonDrawer_1 = require("./PolygonDrawer");
const TriangleDrawer_1 = require("./TriangleDrawer");
async function loadGenericPolygonShape(engine, refresh = true) {
    await engine.addShape("polygon", new PolygonDrawer_1.PolygonDrawer(), refresh);
}
exports.loadGenericPolygonShape = loadGenericPolygonShape;
async function loadTriangleShape(engine, refresh = true) {
    await engine.addShape("triangle", new TriangleDrawer_1.TriangleDrawer(), refresh);
}
exports.loadTriangleShape = loadTriangleShape;
async function loadPolygonShape(engine, refresh = true) {
    await loadGenericPolygonShape(engine, refresh);
    await loadTriangleShape(engine, refresh);
}
exports.loadPolygonShape = loadPolygonShape;
